#include <stdio.h>
#include <stdarg.h>
/* function prototype */
double sumVar3(const char *type, ...);

int main()
{
	double s1, s2;
	s1 = sumVar3("%f %f", 10.0, 20.0f);
	s2 = sumVar3("%d %f %f", 10, 20.0f, 30.0);
	printf("s1 = %f, s2 = %f\n", s1, s2);
	return 0;
}

double sumVar3(const char *type, ...)
{
	int nValue, fValue;
	double sum = 0.0;
	char *p;

	va_list pArg;
	va_start(pArg, type);
	for (p = type; *p != '\0'; p++)
	{
		if (*p == '%')
			p++;
		else
			continue;
		switch (*p)
		{
		case 'd': /*  */
			nValue = va_arg(pArg, int);
			sum += (double) nValue;
			break;
		case 'f': /* ε Ҽ  */
			fValue = va_arg(pArg, double);
			sum += (double) fValue;
			break;
		}
	}
	va_end(pArg);

	return sum;
}
