#include <stdio.h>
#include <stdlib.h>   /* for exit()  */
#define QSIZE   5
enum BOOL { FALSE, TRUE };
enum BOOL isEmptyQueue(int front, int rear);

void addQueue(char queue[], int front, int *rear, char data);
char deleteQueue(char queue[], int *front, int rear);

int main()
{
	int front = 0, rear = 0;
	char queue[QSIZE];
	char data;
	addQueue(queue, front, &rear, 'A');
	addQueue(queue, front, &rear, 'B');
	addQueue(queue, front, &rear, 'C');
	addQueue(queue, front, &rear, 'D');

	/* addQueue(queue, front, &rear, 'E'); */
	while (!isEmptyQueue(front, rear))
	{
		data = deleteQueue(queue, &front, rear);
		printf("deleted data = %c\n", data);
	}
	addQueue(queue, front, &rear, 'F');
	return 0;
}

enum BOOL isEmptyQueue(int front, int rear)
{
	if (front == rear)
		return TRUE;
	else
		return FALSE;
}

void addQueue(char queue[], int front, int *rear, char data)
{
	*rear = (*rear + 1) % QSIZE;
	if (front == *rear)
	{
		printf("Queue full\n");
		exit(1);
	}
	queue[*rear] = data;
}

char deleteQueue(char queue[], int *front, int rear)
{
	/* printf("Delete data from Queue!!!\n"); */
	if (*front == rear)
	{
		printf("Queue empty\n");
		exit(1);
	}
	else
	{
		*front = (*front + 1) % QSIZE;
		return queue[*front];
	}
}
