#include <stdio.h>
#include <malloc.h>
typedef struct node *PNODE;
typedef struct node
{
	int data;
	PNODE link;
} NODE;

PNODE createNode(int data);
void InsertSortedList(PNODE *ptrHead, int key);

int main()
{
	PNODE ptrHead = NULL, ptr;
	InsertSortedList(&ptrHead, 10);
	InsertSortedList(&ptrHead, 5);
	InsertSortedList(&ptrHead, 30);
	InsertSortedList(&ptrHead, 20);
	/*  Ʈ   */
	for (ptr = ptrHead; ptr != NULL; ptr = ptr->link)
		printf("%d -> ", ptr->data);
	return 0;
}

void InsertSortedList(PNODE *head, int key)
{
	PNODE ptr;
	PNODE ptr1, ptr2;
	if (*head == NULL)
	{
		*head = createNode(key);
	}
	else
	{
		ptr = createNode(key);
		ptr1 = *head;
		ptr2 = NULL;

		while (ptr1 && ptr1->data < key)
		{
			ptr2 = ptr1;
			ptr1 = ptr1->link;
		}
		if (ptr2 == NULL)
		{
			ptr->link = *head; /* ptr->link = ptr1 */
			*head = ptr;
		}
		else
		{
			ptr2->link = ptr;
			ptr->link = ptr1;
		}
	}
}

PNODE createNode(int data)
{
	PNODE ptr;
	ptr = (PNODE) malloc(sizeof(NODE));
	ptr->data = data;
	ptr->link = NULL;
	return ptr;
}
