#include <stdio.h>
#include <string.h>
#include <malloc.h>
#define MAXSIZE  5
typedef struct node *PNODE;
typedef struct node {
	char name[20];
	int score;
	PNODE link;
} NODE;

PNODE createNode(char name[], int score);
void InsertSortedList(PNODE *head, char name[], int score);
void printList(PNODE head);
PNODE searchInList(PNODE head, char key[]);

int main()
{
	PNODE ptrHead = NULL, ptr;
	char name[MAXSIZE][20] = { "̿", "ö", "ȫ浿", "տ", "ڹμ" };
	int score[MAXSIZE] = { 80, 90, 60, 50, 70 };
	int i;
	char key[20] = "ö";
	/* char key[20]="ö"; */
	for (i = 0; i < MAXSIZE; i++)
		InsertSortedList(&ptrHead, name[i], score[i]);

	printList(ptrHead); /*  Ʈ   */

	ptr = searchInList(ptrHead, key); /*  Ʈ Ű Ž */
	if (ptr == NULL)
		printf("\n%s ϴ.", key);
	else
		printf("\n%s  %dԴϴ.", ptr->name, ptr->score);
	return 0;
}

PNODE searchInList(PNODE head, char key[])
{
	/* ̸  NULL,    ȯ */
	PNODE ptr;
	ptr = head;
	while (ptr != NULL && strcmp(key, ptr->name) != 0 && strcmp(key, ptr->name) > 0)
		ptr = ptr-> link;

	if (ptr && strcmp(key, ptr->name) != 0)
	{
		return NULL;
	}
	else
		return ptr;
}

void InsertSortedList(PNODE *head, char name[], int score)
{
	PNODE ptr;
	PNODE ptr1, ptr2;
	if (*head == NULL)
	{
		*head = createNode(name, score);
	}
	else
	{
		ptr = createNode(name, score);
		ptr1 = *head;
		ptr2 = NULL;

		while (ptr1 && strcmp(ptr1->name, name) < 0)
		{
			ptr2 = ptr1;
			ptr1 = ptr1->link;
		}
		if (ptr2 == NULL)
		{
			ptr->link = *head; /* ptr->link = ptr1 */
			*head = ptr;
		}
		else
		{
			ptr2->link = ptr;
			ptr->link = ptr1;
		}
	}
}

void printList(PNODE head)
{
	PNODE ptr;
	for (ptr = head; ptr != NULL; ptr = ptr->link)
		printf("%s %d\n", ptr->name, ptr->score);
}

PNODE createNode(char name[], int score)
{
	PNODE ptr;
	ptr = (PNODE) malloc(sizeof(NODE));

/*	strcpy(ptr->name, name); */
	strcpy_s(ptr->name, sizeof(ptr->name), name);
	ptr->score = score;
	ptr->link = NULL;
	return ptr;
}
