#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define MAX  100
void readData(char *, char name[][20], int kor[], int eng[],
		int math[], int *nSize);
void writeData(char *fname, char name[][20], int kor[], int eng[],
		int math[], int sum[], float average[], int nSize);
void calculateAverage(int kor[], int eng[], int math[], int sum[],
		float average[], int nSize);

int main()
{
	int kor[MAX], eng[MAX], math[MAX], sum[MAX];
	char name[MAX][20];
	float average[MAX];
	int nSize;

	readData("data.txt", name, kor, eng, math, &nSize);
	calculateAverage(kor, eng, math, sum, average, nSize);
	writeData("result.txt", name, kor, eng, math, sum, average, nSize);
	return 0;
}

void readData(char *fname, char name[][20], int kor[], int eng[],
		int math[], int *nSize)
{
	int k, e, m;
	char str[20];
	int n = 0;
	FILE *fp;
/*	if ((fp = fopen(fname, "r")) == NULL) */
	fopen_s(&fp, fname, "r");
	if(fp == NULL)
	{
		printf("Է    ϴ.\n");
		exit(1);
	}
/*	while (fscanf(fp, "%s %d %d %d", str, &k, &e, &m) != EOF) */
	while (fscanf_s(fp, "%s %d %d %d", str, sizeof(str), &k, &e, &m) != EOF) /*_countof(str) */
	{
		/* name[n] = str; ϸ   */
	/*	strcpy(name[n], str); */
		strcpy_s(name[n], sizeof(name[n]), str);
		kor[n] = k;
		eng[n] = e;
		math[n] = m;
	/*	printf("%d : %s %d %d %d\n", n, name[n], kor[n], eng[n], math[n]); */
		n++;
	}
	*nSize = n;
	fclose(fp);
}

void writeData(char *fname, char name[][20], int kor[], int eng[],
		int math[], int sum[], float average[], int nSize)
{
	FILE *fp;
	int i;
/*	if ((fp = fopen(fname, "w")) == NULL) */
	fopen_s(&fp, fname, "w");
	if(fp == NULL)
	{
		printf("    ϴ.\n");
		exit(1);
	}

	fprintf(fp, "# :  name    kor  eng math sum  avg\n");
	fprintf(fp, "------------------------------------------\n");
	for (i = 0; i < nSize; i++)
	{
		fprintf(fp, "%d : %6s %4d %4d %4d %4d %10.6f\n", i, name[i], kor[i],
			eng[i], math[i], sum[i], average[i]);
	}
}

void calculateAverage(int kor[], int eng[], int math[],
		int sum[], float average[], int nSize)
{
	int i;
	for (i = 0; i < nSize; i++)
	{
		sum[i] = kor[i] + eng[i] + math[i];
		average[i] = sum[i] / 3.0f;
	}
}
