#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
typedef unsigned char BYTE;  /* 1Ʈ */
typedef unsigned short WORD; /* 2Ʈ */
typedef unsigned long DWORD; /* 4Ʈ */

/* Ǻ  */
#if ( _MSC_VER >= 800 )
/*#include <pshpack2.h> */
#pragma pack(push, 2)
#endif

typedef struct tagBITMAPFILEHEADER {
	WORD bfType;      /* 0x4D42="BM"        */
	DWORD bfSize;     /*  Ʈ ũ */
	WORD bfReserved1; /* ׻ 0             */
	WORD bfReserved2; /* ׻ 0             */
	DWORD bfOffBits;  /* Ʈ   Ʈ */
} BITMAPFILEHEADER;

typedef struct tagBITMAPINFOHEADER { /* bmih */
	DWORD biSize;          /* sizeof(BITMAPINFOHEADER) = 40Ʈ */
	DWORD biWidth;         /* ȼ   ũ   */
	DWORD biHeight;        /* ȼ   ũ   */
	WORD biPlanes;         /* ׻  1               */
	WORD biBitCount;       /* ȼ Ʈ (1, 4, 8, 16, 24, 32)    */
	DWORD bibiCompression; /* : 0(  ),1(RLE-8), 2(RLE-4) */
	DWORD biSizeImage;     /* Ʈ Ʈ ũ  */
	DWORD biXPelsPerMeter; /* ʹ  ȭ ũ */
	DWORD biYPelsPerMeter; /* ʹ  ȭ    */
	DWORD biClrUsed;       /*           */
	DWORD biClrImportant;  /* ߿          */
} BITMAPINFOHEADER;

typedef struct tagRGBQUAD {
	BYTE rgbBlue;  /* Blue  */
	BYTE rgbGreen; /* Green */
	BYTE rgbRed;   /* Red   */
	BYTE rgbReserved;
} RGBQUAD;

#if ( _MSC_VER >= 800 )
/*#include <poppack.h> */
#pragma pack(pop)
#endif

void BmpFileInformation(char fileName[]);

int main()
{
	BmpFileInformation("background.bmp");
	return 0;
}

void BmpFileInformation(char fileName[])
{
	FILE *fp;
	BITMAPFILEHEADER bmFH;
	BITMAPINFOHEADER bmIH;
	RGBQUAD *pRGB;
	BYTE *pBitmap;
	int nColor;
	int nBitmapSize;
	int i;

/*	if ((fp = fopen(fileName, "rb")) == NULL)  */
	fopen_s(&fp, fileName, "rb");
	if(fp == NULL)
	{
		printf("%s   ϴ.", fileName);
		exit(1);
	}
	fread(&bmFH, sizeof(BITMAPFILEHEADER), 1, fp);
	if (bmFH.bfType != 0x4D42)
		return;
	printf("\n Ʈ ũ = %d", bmFH.bfSize);
	printf("\n Ʈ = %d", bmFH.bfOffBits);
	printf("\nReserved1 = %d", bmFH.bfReserved1);
	printf("\nReserved2 = %d", bmFH.bfReserved2);

	fread(&bmIH, sizeof(BITMAPINFOHEADER), 1, fp);
	printf("\nbmIH.biSize = %d", bmIH.biSize);
	printf("\nbmIH.biWidth = %d", bmIH.biWidth);
	printf("\nbmIH.biHeight = %d", bmIH.biHeight);
	printf("\nbmIH.biPlanes = %d", bmIH.biPlanes);
	printf("\nbmIH.biBitCount = %d", bmIH.biBitCount);
	printf("\nbmIH.bibiCompression = %d", bmIH.bibiCompression);
	printf("\nbmIH.biSizeImage = %d", bmIH.biSizeImage);
	printf("\nbmIH.biClrUsed = %d", bmIH.biClrUsed);

	if (bmIH.biBitCount < 16)
	{ /* ε ÷(indexed color)̸ ȷƮ ̺  */
		if (bmIH.biClrUsed == 0) /*     */
			nColor = (1 << bmIH.biBitCount);
		else
			nColor = bmIH.biClrUsed;

		/* ȷƮ ̺ ޸𸮸 Ҵϰ  */
		pRGB = (RGBQUAD*) malloc(nColor * sizeof(RGBQUAD));
		fread(pRGB, sizeof(RGBQUAD), nColor, fp);

		for (i = 0; i < nColor; i++)
			printf("\nRGB[%3d] = [%3d, %3d, %3d]", i, pRGB[i].rgbRed,
					pRGB[i].rgbGreen, pRGB[i].rgbBlue);
	}
	/* (Raw) Ʈ  б */
	nBitmapSize = bmFH.bfSize - bmFH.bfOffBits;
	pBitmap = (BYTE*) malloc(nBitmapSize);
	fread(pBitmap, nBitmapSize, 1, fp);

	/* BMP  ϰ   pBitmap Ϳ
	   bmIH.biWidth  ó
	  :
	 1)  Ʈ  4  
	 2) ϰ (ȭ鿡    Ʒ ׸ κ   ) */

	fclose(fp);
}
