#include <iostream>
using namespace std;
template<class Type, int i>
class CStack
{
	Type *pBuffer;
	int top;
public:
	CStack();
	~CStack();
	void Push(const Type item);
	Type Pop();
	bool IsEmpty();
	bool IsFull();
};

template<class Type, int i>
CStack<Type, i>::CStack()
{
	top = i;
	pBuffer = new Type[i * sizeof(Type)];
}

template<class Type, int i>
CStack<Type, i>::~CStack()
{
	delete pBuffer;
}

template<class Type, int i>
void CStack<Type, i>::Push(const Type item)
{
	if (top > 0)
		pBuffer[--top] = item;
	else
		cout << "Stack full";
}

template<class Type, int i>
Type CStack<Type, i>::Pop()
{
	if (top < i)
		return pBuffer[top++];
	else
	{
		cout << "Stack empty";
		return -1;
	}
}

template<class Type, int i>
bool CStack<Type, i>::IsEmpty()
{
	if (top >= i)
		return true;
	else
		return false;
}

template<class Type, int i>
bool CStack<Type, i>::IsFull()
{
	if (top <= 0)
		return true;
	else
		return false;
}

int main()
{
	CStack<int, 5> test1;
	CStack<char, 5> test2;
	test1.Push(10);
	test1.Push(20);
	test2.Push('A');
	test2.Push('B');
	cout << "test1: ";
	for (; !test1.IsEmpty();)
		cout << test1.Pop() << ", ";
	cout << "\ntest2: ";
	for (; !test2.IsEmpty();)
		cout << test2.Pop() << ", ";
	cout << endl;
	return 0;
}
