#include <iostream>
#include <iterator>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;
int main()
{
	int nArr1[] = { 1, 0, 2 };
	int nArr2[] = { 0, 2, 4 };

	set<int> S1(nArr1, nArr1 + 3);
	set<int> S2(nArr2, nArr2 + 3);

	cout << "S1 = { ";
	copy(S1.begin(), S1.end(), ostream_iterator<int> (cout, " "));
	cout << "}" << endl;
 
	cout << "S1 = { ";
	copy(S2.begin(), S2.end(), ostream_iterator<int> (cout, " "));
	cout << "}" << endl;

	vector<int>::iterator itEnd;
	vector<int> V1(S1.size() + S2.size());

	itEnd = set_intersection(S1.begin(), S1.end(), S2.begin(), S2.end(), V1.begin());
	cout << "Intersection(S1, S2) = { ";
	copy(V1.begin(), itEnd, ostream_iterator<int> (cout, " "));
	cout << "}" << endl;

	itEnd = set_union(S1.begin(), S1.end(), S2.begin(), S2.end(), V1.begin());
	cout << "Union(S1, S2) = { ";
	copy(V1.begin(), itEnd, ostream_iterator<int> (cout, " "));
	cout << "}" << endl;

	itEnd = set_difference(S1.begin(), S1.end(), S2.begin(), S2.end(), V1.begin());
	cout << "Difference(S1, S2) = { ";

	copy(V1.begin(), itEnd, ostream_iterator<int> (cout, " "));
	cout << "}" << endl;

	return 0;
}
