#include <stdio.h>
#include <time.h>
void sleep(clock_t duration);

int main()
{
	time_t timer;
	clock_t start, finish;
	int nTicks;
	char buffer[128];

	time(&timer);
/*	printf("ctime(%ld) = %s\n", timer, ctime(&timer)); */
	ctime_s(buffer, sizeof(buffer), &timer);
	printf("ctime(%ld) = %s\n", timer, buffer);

	start = clock();
	sleep(2000);
	finish = clock();

	nTicks = finish - start;
	printf("start = %d, finish = %d, ticks = %d\n", start, finish, nTicks);
	return 0;
}

void sleep(clock_t duration)
{
	clock_t start;
	start = clock();
	while (clock() < start + duration)
		;
}
