#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
int **IntArray(int nR, int nC);
void FreeIntArray(int **pM, int nR);
void Identity(int **pM, int nR, int nC);
void PrintArray(int **pM, int nR, int nC);

int main()
{
	int **pM;
	int nR = 3; /* (row)     */
	int nC = 3; /* (column)  */
	pM = IntArray(nR, nC);
	Identity(pM, nR, nC);
	PrintArray(pM, nR, nC);
	FreeIntArray(pM, nR);
	return 0;
}

int **IntArray(int nR, int nC)
{
	int i;
	int **pM;
	pM = (int **) malloc(sizeof(int *) * nR); /*  ŭ  迭 ޸ Ҵ */
	if (!pM)
	{
		printf("޸𸮸 Ҵ  ϴ.");
		exit(1);
	}
	/*    迭 nC ޸𸮸 ҴϿ   */
	for (i = 0; i < nR; i++)
	{
		pM[i] = (int *) malloc(sizeof(int) * nC);
		if (!pM)
		{
			printf("޸𸮸 Ҵ  ϴ.");
			exit(1);
		}
	}
	return pM;
}

void FreeIntArray(int **pM, int nR)
{
	int i;
	for (i = 0; i < nR; i++)
		free((int *) (pM[i])); /*    */
	free((int *) pM);          /*   */
}

void Identity(int **pM, int nR, int nC)
{
	int i, j;
	for (i = 0; i < nR; i++)
		for (j = 0; j < nC; j++)
		{
			if (i == j)
				pM[i][j] = 1;
			else
				pM[i][j] = 0;
		}
}

void PrintArray(int **pM, int nR, int nC)
{
	int i, j;
	for (i = 0; i < nR; i++)
	{
		for (j = 0; j < nC; j++)
			printf("%2d", pM[i][j]);
		printf("\n");
	}
}
